# these data are the first "congeneric tests" example
# from Joreskog (1971) and the Lisrel manual
S <- matrix(c(25.0704, 12.4363, 11.7257, 20.7510,
               12.4363, 28.2012, 9.2281, 11.9732,
               11.7257, 9.2281, 22.7390, 12.0692,
               20.7510, 11.9732, 12.0692, 21.8707), 4, 4)
N <- 126

q <- nrow(S)
R <- matrix(1, 1, 1)

# starting values:
theta <- c(4.5, 3, 3, 4.5, 4, 21, 15, 1)
beta <- matrix(theta[1:q], nrow=1, ncol=q)
tau2 <- diag(theta[(q+1):(2*q)], q, q)

# EM loop
for (i in 1:200) {
#	this uses the second computation of the inverse term, top of p. 72
	tau2inverse <- diag(1/diag(tau2))
	inverseterm <- tau2inverse - ((tau2inverse %*% t(beta)) %*%
						(1 / (1 + (beta %*% tau2inverse %*% t(beta)))) %*%
						(beta %*% tau2inverse))

	delta <- inverseterm %*% t(beta)
	CapDelta <- R - ((beta %*% inverseterm) %*% t(beta))
	inverseterm2 <- solve((t(delta) %*% S %*% delta) + CapDelta)

	beta <- inverseterm2 %*% t(S %*% delta)
	tau2 <- diag(diag(S - (S %*% delta %*% beta)))
	print(c(i,beta))
}


Sigma <- (t(beta) %*% R %*% beta) + tau2
SigmaS <- solve(Sigma) %*% S
G2 <- (N-1) * (log(det(Sigma)/det(S)) + sum(diag(SigmaS)) - nrow(S))
print(G2)

