S <- matrix(c(1, .5, .5, .5, .5,
               .5, 1, .5, .5, .5,
               .5, .5, 1, .5, .5,
               .5, .5, .5, 1, .5,
               .5, .5, .5, .5, 1), 5, 5)
N <- 500

ll.FA1J <- function(theta, S, N) {
	q <- nrow(S)
	Phi <- matrix(1, 1, 1)
	Delta <- diag(rep(theta, q), q, q)
	L <- matrix(rep(sqrt(1-theta), q), nrow=1, ncol=q)
	LPL <- t(L) %*% Phi %*% L
	Sigma <- LPL + Delta
	SigmaInverse <- solve(Sigma)
	SigmaS <- SigmaInverse %*% S
	l <- (500/2)*(log(det(Sigma)) + (sum(diag(SigmaS))))
}

# here "theta" is the unique variance, as per Jennrich & Robinson
theta <- 0.5
system.time( result <- nlm(f=ll.FA1J,p=theta,hessian=TRUE,S=S,N=N) )
print(result$estimate)
SE <- sqrt(diag(solve(result$hessian)))
print(SE)

# watch it fail (again)
theta <- 0.64
system.time( result <- nlm(f=ll.FA1J,p=theta,hessian=TRUE,print.level=2,
		S=S,N=N) )

# again, a stepsize limit will bring it in
theta <- 0.64
system.time( result <- nlm(f=ll.FA1J,p=theta,hessian=TRUE,print.level=2,
		stepmax=0.2,S=S,N=N) )



