S <- matrix(c(1, .5, .5, .5, .5,
               .5, 1, .5, .5, .5,
               .5, .5, 1, .5, .5,
               .5, .5, .5, 1, .5,
               .5, .5, .5, .5, 1), 5, 5)
N <- 500

ll.FA2 <- function(theta, S, N) {
	q <- nrow(S)
	L <- matrix(rep(theta[1], q), nrow=1, ncol=q)
	Phi <- matrix(1, 1, 1)
	Delta <- diag(theta[2], q, q)
	LPL <- t(L) %*% Phi %*% L
	Sigma <- LPL + Delta
	SigmaInverse <- solve(Sigma)
	SigmaS <- SigmaInverse %*% S
	l <- (500/2)*(log(det(Sigma)) + (sum(diag(SigmaS))))
}

# both parameters at once, loading and unique variance
# this kind of likelihood is very touchy: this fails:
theta <- c(0.6, 0.8)
system.time( result <- nlm(f=ll.FA2,p=theta,hessian=TRUE,print.level=2,S=S,N=N) )


# the limit on stepsize fixes it:
theta <- c(0.6, 0.8)
system.time( result <- nlm(f=ll.FA2,p=theta,hessian=TRUE,print.level=2,
		stepmax=0.2,S=S,N=N) )

theta <- c(0.7, 0.5)
system.time( result <- nlm(f=ll.FA2,p=theta,hessian=TRUE,print.level=2,
		stepmax=0.2,S=S,N=N) )


