# (there is no Factor-3.R)

# these data are the first "congeneric tests" example
# from Joreskog (1971) and the Lisrel manual
S <- matrix(c(25.0704, 12.4363, 11.7257, 20.7510,
               12.4363, 28.2012, 9.2281, 11.9732,
               11.7257, 9.2281, 22.7390, 12.0692,
               20.7510, 11.9732, 12.0692, 21.8707), 4, 4)
N <- 126

# "congeneric" model:
ll.FA4 <- function(theta, S, N) {
	q <- nrow(S)
	Lambda <- matrix(theta[1:q], nrow=1, ncol=q)
	Phi <- matrix(1, 1, 1)
	Delta <- diag(theta[(q+1):(2*q)], q, q)
	LPL <- t(Lambda) %*% Phi %*% Lambda
	Sigma <- LPL + Delta
	SigmaInverse <- solve(Sigma)
	SigmaS <- SigmaInverse %*% S
	l <- (N/2)*(log(det(Sigma)) + (sum(diag(SigmaS))))
}

theta <- c(4.5, 3, 3, 4.5, 4, 21, 15, 1)
system.time( result <- nlm(f=ll.FA4,p=theta,hessian=TRUE,print.level=2,S=S,N=N) )

print(result$estimate)
print(sqrt(diag(solve(result$hessian))))
# the standard errors here are not even close to those printed by Joreskog (1972)
# however, they do match those in the Lisrel manual

G2 <- (N-1)*((ll.FA4(result$estimate, S, N) / (N/2)) - log(det(S)) - nrow(S))
print(G2)

