# these data are the first "congeneric tests" example
# from Joreskog (1971) and the Lisrel manual
S <- matrix(c(25.0704, 12.4363, 11.7257, 20.7510,
               12.4363, 28.2012, 9.2281, 11.9732,
               11.7257, 9.2281, 22.7390, 12.0692,
               20.7510, 11.9732, 12.0692, 21.8707), 4, 4)
N <- 126

# "tau-equivalent" model
ll.FA6 <- function(theta, S, N) {
	q <- nrow(S)
	Lambda <- matrix(rep(theta[1], q), nrow=1, ncol=q)
	Phi <- matrix(1, 1, 1)
	Delta <- diag(theta[2:(q+1)], q, q)
	LPL <- t(Lambda) %*% Phi %*% Lambda
	Sigma <- LPL + Delta
	SigmaInverse <- solve(Sigma)
	SigmaS <- SigmaInverse %*% S
	l <- (N/2)*(log(det(Sigma)) + (sum(diag(SigmaS))))
}



theta <- c(4, 7, 7, 7, 7)
system.time( result <- nlm(f=ll.FA6,p=theta,hessian=TRUE,print.level=2,S=S,N=N) )

print(result$estimate)
print(sqrt(diag(solve(result$hessian))))

G2 <- (N-1)*((ll.FA6(result$estimate, S, N) / (N/2)) - log(det(S)) - nrow(S))
print(G2)


